------------------
--Config default settings
local t = .5		-- fade time in seconds
local idletimer = 15 -- fade time after idling for x seconds
local isIdle = false
local inraid = false
local chat = true
local whisper = true
local say = true
local raid = true
local party = true
local guild = true
local instance = true
local avm = true
local comm = true
local emote = true
local monster = true
local yell = true
local system = true
local fadealpha = 0
------------------

scfOptions = {}
local scf = CreateFrame("Frame")
local frames = {_}--, GeneralDockManager, ChatFrameMenuButton}
local chatFrames = {}
local MouseoverFrames = {}
local idle = CreateFrame("Frame");
--Events
local event = CreateFrame("Frame")
event:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)

--Register events lazy solution -> register all events, unregister them after loading settings
--TODO? general chat/trade chat
--event:RegisterEvent("ADDON_LOADED") alt?
event:RegisterEvent("PLAYER_REGEN_ENABLED")
event:RegisterEvent("PLAYER_REGEN_DISABLED")
event:RegisterEvent("PLAYER_LOGIN")
event:RegisterEvent("PET_BATTLE_CLOSE")
event:RegisterEvent("PET_BATTLE_OPENING_START")
--event:RegisterEvent("CHAT_MSG_SAY")
--event:RegisterEvent("CHAT_MSG_MONSTER_SAY")
--event:RegisterEvent("CHAT_MSG_WHISPER")
--event:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
--event:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
--event:RegisterEvent("CHAT_MSG_BN_WHISPER")
--event:RegisterEvent("CHAT_MSG_RAID_LEADER")
--event:RegisterEvent("CHAT_MSG_RAID")
--event:RegisterEvent("CHAT_MSG_PARTY_LEADER")
--event:RegisterEvent("CHAT_MSG_PARTY")
--event:RegisterEvent("CHAT_MSG_GUILD")
--event:RegisterEvent("CHAT_MSG_OFFICER")
--event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
--event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
--event:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
--event:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
--event:RegisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
--event:RegisterEvent("CHAT_MSG_EMOTE")
--event:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
--event:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
--event:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
--event:RegisterEvent("CHAT_MSG_MONSTER_WHISPER")
--event:RegisterEvent("CHAT_MSG_MONSTER_YELL")
--event:RegisterEvent("CHAT_MSG_YELL")
--event:RegisterEvent("CHAT_MSG_SYSTEM")
--event:RegisterEvent("TIME_PLAYED_MSG")
--event:RegisterEvent("WHO_LIST_UPDATE")

function event:CHAT_MSG_GUILD_ACHIEVEMENT()
	scf:showChat()
end

function event:CHAT_MSG_ACHIEVEMENT()
	scf:showChat()
end

function event:CHAT_MSG_COMMUNITIES_CHANNEL()
	scf:showChat()
end

function event:CHAT_MSG_EMOTE()
	scf:showChat()
end

function event:CHAT_MSG_TEXT_EMOTE()
	scf:showChat()
end

function event:CHAT_MSG_RAID_BOSS_EMOTE()
	scf:showChat()
end

function event:CHAT_MSG_MONSTER_EMOTE()
	scf:showChat()
end

function event:CHAT_MSG_MONSTER_WHISPER()
	scf:showChat()
end

function event:CHAT_MSG_MONSTER_YELL()
	scf:showChat()
end

function event:CHAT_MSG_YELL()
	scf:showChat()
end

function event:CHAT_MSG_SYSTEM()
	scf:showChat()
end

function event:TIME_PLAYED_MSG()
	scf:showChat()
end

function event:WHO_LIST_UPDATE()
	scf:showChat()
end

function event:CHAT_MSG_INSTANCE_CHAT()
	scf:showChat()
end

function event:CHAT_MSG_INSTANCE_CHAT_LEADER()
	scf:showChat()
end

function event:PLAYER_REGEN_ENABLED()
	if not(isIdle) then
		scf:showChat()
	end
end

function event:PLAYER_REGEN_DISABLED()
	if (isIdle) then
		scf:hideChat()
	end
end

function event:PLAYER_LOGIN()
	scf:Init()
	--scf:raidUpdate()
end

function event:PET_BATTLE_CLOSE()
	scf:showChat()
end

function event:PET_BATTLE_OPENING_START()
	scf:hideChat()
end

function event:CHAT_MSG_SAY()
	scf:showChat()
end

function event:CHAT_MSG_MONSTER_SAY()
	scf:showChat()
end


function event:CHAT_MSG_WHISPER()
	scf:showChat()
end

function event:CHAT_MSG_WHISPER_INFORM()
	scf:showChat()
end

function event:CHAT_MSG_BN_WHISPER_INFORM()
	scf:showChat()
end

function event:CHAT_MSG_BN_WHISPER()
	scf:showChat()
end

function event:CHAT_MSG_RAID_LEADER()
	scf:showChat()
end

function event:CHAT_MSG_RAID()
	scf:showChat()
end

function event:CHAT_MSG_PARTY_LEADER()
	scf:showChat()
end

function event:CHAT_MSG_PARTY()
	scf:showChat()
end

function event:CHAT_MSG_GUILD()
	scf:showChat()
end

function event:CHAT_MSG_OFFICER()
	scf:showChat()
end



--function event:GROUP_ROSTER_UPDATE()
--	scf:raidUpdate()
--end

--Config load user settings
function scf:getOptions()

	if scfOptions.t ~= nil then
		t = scfOptions.t
		scf:sett(scfOptions.t)
	else
		scf:sett(t)
	end
	
	if scfOptions.idletimer ~= nil then
		idletimer = scfOptions.idletimer
		scf:setidletimer(scfOptions.idletimer)
	else
		scf:setidletimer(idletimer)
	end

	if scfOptions.inraid ~= nil then
		inraid = scfOptions.inraid
		scf:setinraid(scfOptions.inraid)
	else
		scf:setinraid(inraid)
	end
	
	if scfOptions.chat ~= nil then
		chat = scfOptions.chat
		scf:setchat(scfOptions.chat)
	else
		scf:setchat(chat)
	end
	
	if scfOptions.whisper ~= nil then
		whisper = scfOptions.whisper
		scf:setwhisper(scfOptions.whisper)
	else
		scf:setwhisper(whisper)
	end
	
	if scfOptions.say ~= nil then
		say = scfOptions.say
		scf:setsay(scfOptions.say)
	else
		scf:setsay(say)
	end
	
	if scfOptions.guild ~= nil then
		guild = scfOptions.guild
		scf:setguild(scfOptions.guild)
	else
		scf:setguild(guild)
	end
	
	if scfOptions.party ~= nil then
		party = scfOptions.party
		scf:setparty(scfOptions.party)
	else
		scf:setparty(party)
	end
	
	if scfOptions.raid ~= nil then
		raid = scfOptions.raid
		scf:setraid(scfOptions.raid)
	else
		scf:setraid(raid)
	end
	
	if scfOptions.instance ~= nil then
		instance = scfOptions.instance
		scf:setinstance(scfOptions.instance)
	else
		scf:setinstance(instance)
	end 
	
	if scfOptions.avm ~= nil then
		avm = scfOptions.avm
		scf:setavm(scfOptions.avm)
	else
		scf:setavm(avm)
	end
	
	if scfOptions.comm ~= nil then
		comm = scfOptions.comm
		scf:setcomm(scfOptions.comm)
	else
		scf:setcomm(comm)
	end
	
	if scfOptions.emote ~= nil then
		emote = scfOptions.emote
		scf:setemote(scfOptions.emote)
	else
		scf:setemote(emote)
	end
	
	if scfOptions.monster ~= nil then
		monster = scfOptions.monster
		scf:setmonster(scfOptions.monster)
	else
		scf:setmonster(monster)
	end
	
	if scfOptions.yell ~= nil then
		yell = scfOptions.yell
		scf:setyell(scfOptions.yell)
	else
		scf:setyell(yell)
	end
	
	if scfOptions.fadealpha ~= nil then
		fadealpha = scfOptions.fadealpha
		scf:setfadealpha(scfOptions.fadealpha)
	else
		scf:setfadealpha(fadealpha)
	end
	
	if scfOptions.system ~= nil then
		system = scfOptions.system
		scf:setsystem(scfOptions.system)
	else
		scf:setsystem(system)
	end
end


--update the disable bool depending on settings and raidstatus
--function scf:raidUpdate()
--print(inraid)
--	if ((inraid and IsInRaid()) or not(inraid)) then
--		disable = false
--	else
--		disable = true
--	end
--end

--options panel
local panel = CreateFrame("FRAME")

function scf:createPanel()

	panel.name = "Smart Chat Fade"
	InterfaceOptions_AddCategory(panel)

	panel.okay = function (self) scf:okay(); end;
	panel.cancel = function (self) scf:canel(); end;
	panel.default = function (self) scf:default(); end;

	local templatecheck = "ChatConfigCheckButtonTemplate"
	local ypos = -25
	local xpos = 25
	local ydis = -20

	local inraidcheck = CreateFrame("CheckButton", "inraid", panel, templatecheck)
	inraidcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(inraidcheck:GetName() .. 'Text'):SetText("in raid only")
	inraidcheck.tooltip = "only hides chat if you are in a raidgroup"
	inraidcheck:SetChecked(inraid)
	inraidcheck:SetScript("OnClick", 
	function()
		scf:setinraid(inraidcheck:GetChecked())
	end
	);

	local chatcheck = CreateFrame("CheckButton", "chat", panel, templatecheck)
	ypos = ypos + ydis
	chatcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(chatcheck:GetName() .. 'Text'):SetText("track chat events: ")
	chatcheck.tooltip = "if you only want combat to hide chat you should uncheck this"
	chatcheck:SetChecked(chat)
	chatcheck:SetScript("OnClick", 
	function()
			scf:setchat(chatcheck:GetChecked())
	end
	);

	xpos = xpos + 25

	local whispercheck = CreateFrame("CheckButton", "whisper", panel, templatecheck)
	ypos = ypos + ydis
	whispercheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(whispercheck:GetName() .. 'Text'):SetText("whisper")
	--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	whispercheck:SetChecked(whisper)
	whispercheck:SetScript("OnClick", 
	function()
			scf:setwhisper(whispercheck:GetChecked())
	end
	);

	local saycheck = CreateFrame("CheckButton", "say", panel, templatecheck)
	ypos = ypos + ydis
	saycheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(saycheck:GetName() .. 'Text'):SetText("say")
		--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	saycheck:SetChecked(say)
	saycheck:SetScript("OnClick", 
	function()
			scf:setsay(saycheck:GetChecked())
	end
	);
	
	local yellcheck = CreateFrame("CheckButton", "yell", panel, templatecheck)
	ypos = ypos + ydis
	yellcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(yellcheck:GetName() .. 'Text'):SetText("yell")
		--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	yellcheck:SetChecked(yell)
	yellcheck:SetScript("OnClick", 
	function()
			scf:setyell(yellcheck:GetChecked())
	end
	);
	
	local guildcheck = CreateFrame("CheckButton", "guild", panel, templatecheck)
	ypos = ypos + ydis
	guildcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(guildcheck:GetName() .. 'Text'):SetText("guild")
		--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	guildcheck:SetChecked(guild)
	guildcheck:SetScript("OnClick", 
	function()
			scf:setguild(guildcheck:GetChecked())
	end
	);
	
	local partycheck = CreateFrame("CheckButton", "party", panel, templatecheck)
	ypos = ypos + ydis
	partycheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(partycheck:GetName() .. 'Text'):SetText("party")
		--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	partycheck:SetChecked(party)
	partycheck:SetScript("OnClick", 
	function()
			scf:setparty(partycheck:GetChecked())
	end
	);
	
	local raidcheck = CreateFrame("CheckButton", "raid", panel, templatecheck)
	ypos = ypos + ydis
	raidcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(raidcheck:GetName() .. 'Text'):SetText("raid")
		--whispercheck.tooltip = "if you only want combat to hide chat you should uncheck this."
	raidcheck:SetChecked(raid)
	raidcheck:SetScript("OnClick", 
	function()
			scf:setraid(raidcheck:GetChecked())
	end
	);
	
	local instancecheck = CreateFrame("CheckButton", "instance", panel, templatecheck)
	ypos = ypos + ydis
	instancecheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(instancecheck:GetName() .. 'Text'):SetText("instance")
	instancecheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	instancecheck:SetChecked(instance)
	instancecheck:SetScript("OnClick", 
	function()
			scf:setinstance(instancecheck:GetChecked())
	end
	);
	
	local commcheck = CreateFrame("CheckButton", "comm", panel, templatecheck)
	ypos = ypos + ydis
	commcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(commcheck:GetName() .. 'Text'):SetText("community")
	--commcheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	commcheck:SetChecked(comm)
	commcheck:SetScript("OnClick", 
	function()
			scf:setcomm(commcheck:GetChecked())
	end
	);

	local avmcheck = CreateFrame("CheckButton", "avm", panel, templatecheck)
	ypos = ypos + ydis
	avmcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(avmcheck:GetName() .. 'Text'):SetText("achievements")
	--avmcheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	avmcheck:SetChecked(avm)
	avmcheck:SetScript("OnClick", 
	function()
			scf:setavm(avmcheck:GetChecked())
	end
	);

	local emotecheck = CreateFrame("CheckButton", "emote", panel, templatecheck)
	ypos = ypos + ydis
	emotecheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(emotecheck:GetName() .. 'Text'):SetText("emotes")
	--emotecheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	emotecheck:SetChecked(emote)
	emotecheck:SetScript("OnClick", 
	function()
			scf:setemote(emotecheck:GetChecked())
	end
	);

	local monstercheck = CreateFrame("CheckButton", "monster", panel, templatecheck)
	ypos = ypos + ydis
	monstercheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(monstercheck:GetName() .. 'Text'):SetText("monster")
	monstercheck.tooltip = "anything environment related"
	monstercheck:SetChecked(monster)
	monstercheck:SetScript("OnClick", 
	function()
			scf:setmonster(monstercheck:GetChecked())
	end
	);

	local systemcheck = CreateFrame("CheckButton", "system", panel, templatecheck)
	ypos = ypos + ydis
	systemcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(systemcheck:GetName() .. 'Text'):SetText("system messages")
	systemcheck.tooltip = "stuff like /played, /who and general yellow system text"
	systemcheck:SetChecked(system)
	systemcheck:SetScript("OnClick", 
	function()
			scf:setsystem(systemcheck:GetChecked())
	end
	);
	
	ypos = ypos + ydis*2
	xpos = xpos - 25
	
	local idletimerslider = CreateFrame("Slider", "idletimersliderGlobalName", panel, "OptionsSliderTemplate")
	idletimerslider:SetPoint("TOPLEFT", xpos, ypos)
	idletimerslider:SetWidth(150)
	idletimerslider:SetHeight(15)
	idletimerslider:SetOrientation('HORIZONTAL')
	--idletimerslider.tooltipText = 'This is the Tooltip hint' --Creates a tooltip on mouseover.
	getglobal(idletimerslider:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
	getglobal(idletimerslider:GetName() .. 'High'):SetText('30'); --Sets the right-side slider text (default is "High").
	getglobal(idletimerslider:GetName() .. 'Text'):SetText('time until chat hides'); --Sets the "title" text (top-centre of slider).
	idletimerslider:SetMinMaxValues(1, 30)
	idletimerslider:SetValue(idletimer)
	idletimerslider:SetValueStep(1)
	idletimerslider:SetScript("OnValueChanged", function(self,event,arg1) scf:setidletimer(event) end)
	
	ypos = ypos + ydis*2
	
	local fadealphaslider = CreateFrame("Slider", "fadealphasliderGlobalName", panel, "OptionsSliderTemplate")
	fadealphaslider:SetPoint("TOPLEFT", xpos, ypos)
	fadealphaslider:SetWidth(150)
	fadealphaslider:SetHeight(15)
	fadealphaslider:SetOrientation('HORIZONTAL')
	--idletimerslider.tooltipText = 'This is the Tooltip hint' --Creates a tooltip on mouseover.
	getglobal(fadealphaslider:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(fadealphaslider:GetName() .. 'High'):SetText('100'); --Sets the right-side slider text (default is "High").
	getglobal(fadealphaslider:GetName() .. 'Text'):SetText('alpha of faded chat, 0% = fully hidden'); --Sets the "title" text (top-centre of slider).
	fadealphaslider:SetMinMaxValues(0, 100)
	fadealphaslider:SetValue(fadealpha)
	fadealphaslider:SetValueStep(4)
	fadealphaslider:SetScript("OnValueChanged", function(self,event,arg1) scf:setfadealpha(event) end)

end

function scf:setsystem(setting)
	scfOptions.system = setting
	system = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_SYSTEM")
		event:RegisterEvent("TIME_PLAYED_MSG")
		event:RegisterEvent("WHO_LIST_UPDATE")
	else
		event:UnregisterEvent("CHAT_MSG_SYSTEM")
		event:UnregisterEvent("TIME_PLAYED_MSG")
		event:UnregisterEvent("WHO_LIST_UPDATE")
	end
end

function scf:setmonster(setting)
	scfOptions.monster = setting
	monster = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:RegisterEvent("CHAT_MSG_MONSTER_WHISPER")
	else
		event:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_WHISPER")
	end
end

function scf:setemote(setting)
	scfOptions.emote = setting
	emote = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_EMOTE")
		event:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	else
		event:UnregisterEvent("CHAT_MSG_EMOTE")
		event:UnregisterEvent("CHAT_MSG_TEXT_EMOTE")
	end
end

function scf:setavm(setting)
	scfOptions.avm = setting
	avm = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
	else
		event:UnregisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_ACHIEVEMENT")
	end
end

function scf:setcomm(setting)
	scfOptions.comm = setting
	comm = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
	else
		event:UnregisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
	end
end

function scf:setinstance(setting)
	scfOptions.instance = setting
	instance = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
	else
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
	end
end

function scf:setraid(setting)
	scfOptions.raid = setting
	raid = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_RAID_LEADER")
		event:RegisterEvent("CHAT_MSG_RAID")
	else
		event:UnregisterEvent("CHAT_MSG_RAID_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID")
	end
end

function scf:setparty(setting)
	scfOptions.party = setting
	party = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_PARTY_LEADER")
		event:RegisterEvent("CHAT_MSG_PARTY")
	else
		event:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		event:UnregisterEvent("CHAT_MSG_PARTY")
	end
end

function scf:setguild(setting)
	scfOptions.guild = setting
	guild = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_GUILD")
		event:RegisterEvent("CHAT_MSG_OFFICER")
	else
		event:UnregisterEvent("CHAT_MSG_GUILD")
		event:UnregisterEvent("CHAT_MSG_OFFICER")
	end
end

function scf:setyell(setting)
	scfOptions.yell = setting
	yell = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_MONSTER_YELL")
		event:RegisterEvent("CHAT_MSG_YELL")
	else
		event:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		event:UnregisterEvent("CHAT_MSG_YELL")	
	end
end

function scf:setsay(setting)
	scfOptions.say = setting
	say = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_SAY")
		event:RegisterEvent("CHAT_MSG_MONSTER_SAY")
	else
		event:UnregisterEvent("CHAT_MSG_SAY")
		event:UnregisterEvent("CHAT_MSG_MONSTER_SAY")	
	end
end

function scf:setwhisper(setting)
	scfOptions.whisper = setting
	whisper = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_WHISPER")
		event:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:RegisterEvent("CHAT_MSG_BN_WHISPER")
	else
		event:UnregisterEvent("CHAT_MSG_WHISPER")
		event:UnregisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER")		
	end
end

function scf:setchat(setting)
	scfOptions.chat = setting
	chat = setting
	if setting then
		scf:setwhisper(whisper)
		scf:setsay(say)
		scf:setyell(yell)
		scf:setguild(guild)
		scf:setparty(party)
		scf:setraid(raid)
		scf:setinstance(instance)
		scf:setcomm(comm)
		scf:setavm(avm)
		scf:setemote(emote)
		scf:setmonster(monster)
		scf:setsystem(system)
	else
		event:UnregisterEvent("CHAT_MSG_SYSTEM")
		event:UnregisterEvent("TIME_PLAYED_MSG")
		event:UnregisterEvent("WHO_LIST_UPDATE")
		event:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_WHISPER")
		event:UnregisterEvent("CHAT_MSG_EMOTE")
		event:UnregisterEvent("CHAT_MSG_TEXT_EMOTE")
		event:UnregisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID")
		event:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		event:UnregisterEvent("CHAT_MSG_PARTY")
		event:UnregisterEvent("CHAT_MSG_GUILD")
		event:UnregisterEvent("CHAT_MSG_OFFICER")
		event:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		event:UnregisterEvent("CHAT_MSG_YELL")	
		event:UnregisterEvent("CHAT_MSG_SAY")
		event:UnregisterEvent("CHAT_MSG_MONSTER_SAY")	
		event:UnregisterEvent("CHAT_MSG_WHISPER")
		event:UnregisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER")	
	end
end

function scf:setinraid(setting)
	scfOptions.inraid = setting
	inraid = setting
	if setting then
		scf:showChat()
	end
end

function scf:sett(setting)
	scfOptions.t = setting
	t = setting
end

function scf:setidletimer(setting)
	--print(setting)
	scfOptions.idletimer = setting
	idletimer = setting
	isIdle = false
end

function scf:setfadealpha(setting)
	--print(setting)
	scfOptions.fadealpha = setting
	fadealpha = setting
end

function idle:onUpdate(sinceLastUpdate)
	--print(idletimer, sinceLastUpdate)
	if ((inraid and IsInRaid()) or not(inraid)) then
	self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate;
	if (( self.sinceLastUpdate >= idletimer ) and (isIdle == false)) then -- in seconds
		isIdle = true
		self.sinceLastUpdate = 0;
		scf:hideChat()
		
	elseif self.sinceLastUpdate >= 2147483645 then
		self.sinceLastUpdate = idletimer + 1
	end
	end
end


	
	idle:SetScript("OnUpdate",idle.onUpdate)



--
function scf:Init()
	scf:getOptions()
	scf:createPanel()
	for i=1,NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i]
		if(f:IsShown()) then
			local chatMouseover = CreateFrame("Frame", "scf"..i, UIParent)
			chatMouseover:SetPoint("BOTTOMLEFT", "ChatFrame"..i, "BOTTOMLEFT", -20, -10)
			chatMouseover:SetPoint("TOPRIGHT", "ChatFrame"..i, "TOPRIGHT", 10, 10)

			chatMouseover.FadeOut = function (self) scf:FadeOut(self) end
			chatMouseover.FadeIn = function (self) scf:FadeIn(self) end
			
			chatMouseover:SetScript("OnEnter", function(self)
				if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() or isIdle then
					self:FadeIn(self)
					isIdle = false
					idle.sinceLastUpdate = 0
				end
			end)
			chatMouseover:SetScript("OnLeave", function(self)
				scf:ChatOnLeave(self)
				idle.sinceLastUpdate = 0
			end)
			
			chatMouseover.Frames = {_G["ChatFrame"..i], _G["ChatFrame"..i.."Tab"], _G["ChatFrame"..i.."ButtonFrame"]}
			if (i==1) then
				table.insert(chatMouseover.Frames, GeneralDockManager)
				table.insert(chatMouseover.Frames, GeneralDockManagerScrollFrame)
				if ChatFrameMenuButton:IsShown() then
					table.insert(chatMouseover.Frames, ChatFrameMenuButton)
				end
				table.insert(chatMouseover.Frames, QuickJoinToastButton)
				table.insert(chatMouseover.Frames, ChatFrameChannelButton)
				--table.insert(chatMouseover.Frames, ChatFrame1EditBox)
			end
			
			chatMouseover:SetFrameStrata("BACKGROUND")
			table.insert(MouseoverFrames, _G["scf"..i])
		end
	end
end

--
function scf:hideChat()
	
		for _, f in pairs(MouseoverFrames) do
			f:FadeOut()
		end
		isIdle = true
	
end

--
function scf:showChat()
	for _, f in pairs(MouseoverFrames) do
		f:FadeIn()
	end
	idle.sinceLastUpdate = 0
	isIdle = false
end




--Fade
--0: fade in, 1: fade out
function scf:FadeOut(self)
	scf:fade(self, 1)
end
function scf:FadeIn(self)
	scf:fade(self, 0)
end
function scf:fade(self, mode)
	for _, frame in pairs(self.Frames) do
		local alpha = frame:GetAlpha()
		--fade in
		if mode == 0 then
			frame.Show = Show
			frame:Show()
			UIFrameFadeIn(frame, t*(1-alpha), alpha, 1)
		--fade out
		else
			UIFrameFadeOut(frame, t*alpha, alpha, (fadealpha / 100))
			frame.Show = function() end
			if fadealpha == 0 then
				frame.fadeInfo.finishedArg1 = frame
				frame.fadeInfo.finishedFunc = frame.Hide
			end
		end
	end	
end

function scf:ChatOnLeave(self)
	local f = GetMouseFocus()
	if f then
		if f.messageInfo then
			return nil
		end
		if scf:IsInArray(self.Frames, f) then
			return nil
		end
		if f:GetParent() then
			f = f:GetParent()
			if scf:IsInArray(self.Frames, f) then
				return nil
			end
			if f:GetParent() then
				f = f:GetParent()
				if scf:IsInArray(self.Frames, f) then
					return nil
				end
			end
		end
	end

	--if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() or isIdle then
	--	idle.sinceLastUpdate = 0
	--	self:FadeOut(self)
	--end
end


--WorldFrame:HookScript("OnEnter", function()
--	if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() then
--		scf:hideChat()
--	end
--end)

function scf:IsInArray(array, s)
	for _, v in pairs(array) do
		if (v == s) then
			return true
		end
	end
	return false
end

hooksecurefunc("FCF_Tab_OnClick", function(self)
	chatFrame = _G["ChatFrame"..self:GetID()];
	if (chatFrame.isDocked) then
		scf1.Frames[1] = chatFrame
	end
end)



